package com.szhis.frsoft.emr.service.outpatient;

package ..deTemp.1737707697768;

import com.szhis.frsoft.common.SpringApplicationContext;
import com.szhis.frsoft.common.context.eventmsg.EntityUpdateMessage;
import com.szhis.frsoft.common.exception.ThrowException;
import com.szhis.frsoft.common.utils.BigDecimalUtils;
import com.szhis.frsoft.common.utils.DateUtils;
import com.szhis.frsoft.common.utils.IntegerUtils;
import com.szhis.frsoft.common.utils.JPAUtils;
import com.szhis.frsoft.common.utils.SpringBeanUtilsEx;
import com.szhis.frsoft.common.utils.StringUtils;
import com.szhis.frsoft.emr.service.bo.MZYZDBo;
import com.szhis.frsoft.emr.service.bo.OutRpOrdersBo;
import com.szhis.frsoft.emr.service.bo.emrParams;
import com.szhis.frsoft.emr.service.common.EmrCommonService;
import com.szhis.frsoft.emr.service.outpatient.order.OutIndexChargeBillService;
import com.szhis.frsoft.entity.emr.basic.YZDBase;
import com.szhis.frsoft.entity.emr.basic.YZDMXBase;
import com.szhis.frsoft.entity.emr.basic.YZZLSQDBase;
import com.szhis.frsoft.entity.emr.basic.outpatient.MZYZDMX;
import com.szhis.frsoft.entity.his.mzgh.MZGHJL;
import com.szhis.frsoft.entity.his.mzsf.MZJZJL;
import com.szhis.frsoft.entity.his.mzsf.MZSFD;
import com.szhis.frsoft.entity.his.mzsf.MZSFDCLMX;
import com.szhis.frsoft.entity.his.mzsf.MZSFDMX;
import com.szhis.frsoft.entity.his.mzsf.MZSFDSFXMMX;
import com.szhis.frsoft.entity.his.mzsf.MZSFDYPMX;
import com.szhis.frsoft.entity.his.mzys.MZBLBD;
import com.szhis.frsoft.entity.his.mzys.MZYZCS;
import com.szhis.frsoft.entity.his.mzys.MZYZD;
import com.szhis.frsoft.entity.his.mzys.MZYZDYPMX;
import com.szhis.frsoft.entity.his.mzys.MZYZDZLMX;
import com.szhis.frsoft.entity.his.mzys.MZYZJJ;
import com.szhis.frsoft.entity.his.mzys.MZYZZD;
import com.szhis.frsoft.entity.his.mzys.MZYZZLSQD;
import com.szhis.frsoft.entity.lis.other.LISMZWJZTX;
import com.szhis.frsoft.entity.mi.mz.YBMZGHJL;
import com.szhis.frsoft.entity.operation.mz.MZSSJL;
import com.szhis.frsoft.entity.pub.ChargeItem;
import com.szhis.frsoft.entity.pub.clml.CLMLB;
import com.szhis.frsoft.entity.pub.dict.DictConst;
import com.szhis.frsoft.entity.pub.sfxm.SFXMB;
import com.szhis.frsoft.entity.pub.ypml.YPCLMLB;
import com.szhis.frsoft.entity.pub.ypml.YPMLB;
import com.szhis.frsoft.entity.vip.HYZH;
import com.szhis.frsoft.fr.FRApplication;
import com.szhis.frsoft.fr.LoginUser;
import com.szhis.frsoft.pub.service.FRPubService;
import com.szhis.frsoft.service.emr.MedicalTechnologyStationService;
import com.szhis.frsoft.service.his.billing.ItemBillingService;
import com.szhis.frsoft.service.his.billing.bo.SelectedChargeItemsInfo;
import com.szhis.frsoft.service.his.mzsf.OutChargeBillService;
import com.szhis.frsoft.service.his.mzsf.OutCheckoutApi;
import com.szhis.frsoft.service.his.mzsf.bo.OutChargeBillsInfo;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional
public class OutPatientService {
  private static Logger logger = LoggerFactory.getLogger(com.szhis.frsoft.emr.service.outpatient.OutPatientService.class);
  
  @Autowired(required = false)
  private OutChargeBillService billService;
  
  @Autowired(required = false)
  private ItemBillingService itemBillService;
  
  @Autowired(required = false)
  private OutCheckoutApi outApi;
  
  @Autowired(required = false)
  private MedicalTechnologyStationService mtsService;
  
  @Autowired(required = false)
  private EmrCommonService emrCommonService;
  
  public void updateZt_4(Integer YZDLsh, Integer SFDLsh) {
    MZYZD result = (MZYZD)JPAUtils.findOne(MZYZD.class, YZDLsh);
    if (result == null || result.getZt().equals(DictConst.YZDMXZT_作废) || result.getZt().equals(DictConst.YZDMXZT_删除))
      return; 
    result.setZt(DictConst.YZDZT_已收费);
    result.setXgsj(new Date());
    JPAUtils.save(result);
    if (this.mtsService != null && this.mtsService.enabled() && !IntegerUtils.isNullOrZero(result.getZlsl()).booleanValue()) {
      List<MZYZCS> csLs = JPAUtils.query("select a from MZYZCS a where a.yZDlsh=? and a.scbj=0", new Object[] { YZDLsh });
      if (csLs.size() > 0) {
        List<MZYZDZLMX> ls = JPAUtils.query("select a from MZYZDZLMX a where a.yZDlsh=? and a.zt>1", new Object[] { YZDLsh });
        Map<Integer, MZYZDZLMX> index = new HashMap<>(ls.size());
        for (MZYZDZLMX temp : ls)
          index.put(temp.getLsh(), temp); 
        MZYZDZLMX yzdmx = null;
        for (MZYZCS temp : csLs) {
          yzdmx = index.get(temp.getyZDMXlsh());
          if (yzdmx != null)
            this.mtsService.build((YZDMXBase)yzdmx, temp); 
        } 
      } 
    } 
  }
  
  public void updateZt_4_jzjl(List<MZJZJL> src, boolean build) {
    if (src.isEmpty())
      return; 
    boolean useLisMsg = DictConst.Str_1.equals(FRApplication.getParamValue(Integer.valueOf(1045)));
    boolean useMtsService = (this.mtsService != null && this.mtsService.enabled() && build);
    if (!useLisMsg && !useMtsService) {
      if (this.mtsService != null && !DictConst.Int_2.equals(emrParams.param_LisSyncMode()))
        this.mtsService.updateYLFWXMTXLastDate("E", DictConst.YLFWLX_门诊, new Date()); 
      return;
    } 
    List<Integer> yzdmx = null;
    Integer brid = ((MZJZJL)src.get(0)).getBrjbxx().getId();
    if (src.size() == 1) {
      String jpql = "select distinct a.mZYZDMXlsh from MZSFDSFXMMX a join a.brjbxx b where b.id = ?1 and a.mZYZDMXlsh>0 and a.mzjzjl.lsh = ?2";
      MZJZJL mzjzjl = src.get(0);
      yzdmx = JPAUtils.query(jpql, new Object[] { brid, mzjzjl.getLsh() });
    } else {
      List<Integer> ids = new ArrayList<>(src.size());
      for (MZJZJL temp : src)
        ids.add(temp.getLsh()); 
      String jpql = "select distinct a.mZYZDMXlsh from MZSFDSFXMMX a join a.brjbxx b where b.id = ?1 and a.mZYZDMXlsh>0 and a.mzjzjl.lsh in (?2)";
      yzdmx = JPAUtils.query(jpql, new Object[] { brid, ids });
    } 
    if (yzdmx.size() == 0) {
      if (useLisMsg && this.mtsService != null)
        this.mtsService.updateYLFWXMTXLastDate("E", DictConst.YLFWLX_门诊, new Date()); 
      return;
    } 
    List<YZDMXBase> ls = JPAUtils.query("select a from MZYZDZLMX a where a.lsh in (?1) and a.zt>1 and a.xmlx=4", new Object[] { yzdmx });
    if (useMtsService)
      this.mtsService.buildItems(ls, ((MZJZJL)src.get(0)).getMzghjl().getbRJBXXmzh(), DictConst.Int_0); 
    if (useLisMsg) {
      List<Integer> lisIds = null;
      for (YZDMXBase temp : ls) {
        if ("E".equals(temp.getyLFWXMTXbh())) {
          if (lisIds == null)
            lisIds = new ArrayList<>(ls.size()); 
          lisIds.add(temp.getLsh());
        } 
      } 
      if (lisIds != null) {
        if (this.mtsService != null && !DictConst.Int_2.equals(emrParams.param_LisSyncMode()))
          this.mtsService.updateYLFWXMTXLastDate("E", DictConst.YLFWLX_门诊, new Date()); 
        EntityUpdateMessage<Integer> content = new EntityUpdateMessage("LISSQD", new Date(), lisIds);
        if (build) {
          FRApplication.getEventMessageManager().send(-11, content);
        } else {
          FRApplication.getEventMessageManager().send(-12, content);
        } 
      } 
    } 
  }
  
  public MZYZD deleteRpFromLsh(Integer lsh, Integer flag, MZYZD src) {
    MZYZD result = (MZYZD)JPAUtils.findOne(MZYZD.class, lsh);
    if (result == null)
      ThrowException.runtime("emr.yzd.lsh.notFound", new Object[] { lsh }); 
    MZYZDBo bo = new MZYZDBo();
    bo.setRegisterLsh(result.getRegisterLsh());
    bo.setXgrYGid(LoginUser.getyGid());
    bo.setXgrYGxm(LoginUser.getYg().getXm());
    bo.setXgsj(new Date());
    cancelMedicalOrder(bo, result, null, IntegerUtils.isBitOn(flag, 1), IntegerUtils.isBitOn(flag, 4));
    if (IntegerUtils.isBitOn(flag, 2)) {
      bo.setFlag(Integer.valueOf(DictConst.Int_1.intValue() | DictConst.Int_4.intValue()));
    } else if (IntegerUtils.isBitOn(flag, 3)) {
      bo.setFlag(Integer.valueOf(DictConst.Int_2.intValue() | DictConst.Int_4.intValue()));
    } else {
      bo.setFlag(DictConst.Int_0);
    } 
    if (!bo.getFlag().equals(DictConst.Int_0)) {
      if (bo.getRegister() == null) {
        MZGHJL ghjl = (MZGHJL)JPAUtils.findOne(MZGHJL.class, result.getRegisterLsh());
        bo.setRegister(ghjl);
      } 
      updateMZGHD(bo);
    } 
    result.setCxrYGid(bo.getXgrYGid());
    result.setCxrYGxm(bo.getXgrYGxm());
    result.setCxsj(bo.getXgsj());
    result.setXgsj(bo.getXgsj());
    if (src != null)
      result.setCxyy(src.getCxyy()); 
    return result;
  }
  
  private MZYZD InitYZD(MZYZD yzd, MZYZDBo bo, List<MZYZD> oldYzdList) {
    if (yzd.getLsh().intValue() < 1) {
      yzd.setLsh(null);
      yzd.setbRJBXXid(bo.getRegister().getBrjbxx().getId());
      yzd.setRegisterLsh(bo.getRegister().getLsh());
      if (yzd.getKdrYGid() == null) {
        yzd.setKdrYGid(bo.getXgrYGid());
        yzd.setKdrYGxm(bo.getXgrYGxm());
      } 
      if (yzd.getJzKSid() == null)
        yzd.setJzKSid(yzd.getKdKSid()); 
      if (yzd.getZrYGid() == null) {
        yzd.setZrYGid(yzd.getKdrYGid());
        yzd.setZrYGxm(yzd.getKdrYGxm());
      } 
      yzd.setKdsj(bo.getXgsj());
      yzd.setLrrYGid(bo.getXgrYGid());
      yzd.setLrrYGxm(bo.getXgrYGxm());
      yzd.setLrsj(bo.getXgsj());
      yzd.setXgrYGid(bo.getXgrYGid());
      yzd.setXgrYGxm(bo.getXgrYGxm());
      yzd.setXgsj(bo.getXgsj());
      if (yzd.getZt() == null)
        yzd.setZt(DictConst.YZDZT_新单); 
      if (bo.getSendRp().booleanValue())
        yzd.setZt(DictConst.YZDZT_已发送); 
      yzd = (MZYZD)JPAUtils.save(yzd);
      if (StringUtils.isEmpty(yzd.getDh()))
        yzd.setDh(yzd.getLsh().toString()); 
      return yzd;
    } 
    MZYZD old = null;
    for (MZYZD temp : oldYzdList) {
      if (temp != null && temp.getLsh().equals(yzd.getLsh())) {
        old = temp;
        break;
      } 
    } 
    if (old == null)
      ThrowException.runtime("emr.yzd.lsh.notFound", new Object[] { yzd.getLsh() }); 
    if (!old.getVersion().equals(yzd.getVersion()))
      ThrowException.runtime("emr.version.changed", new Object[] { old.getDh(), old.getLsh() }); 
    if (old.getZt().compareTo(DictConst.YZDZT_新单) < 0 || old.getZt().compareTo(DictConst.YZDZT_已发送) > 0)
      ThrowException.runtime("emr.yzd.zt." + old.getZt().toString(), new Object[] { old.getLsh() }); 
    if (bo.getSendRp().booleanValue())
      old.setZt(DictConst.YZDZT_已发送); 
    old.setClsl(yzd.getClsl());
    old.setZlsl(yzd.getZlsl());
    old.setYpsl(yzd.getYpsl());
    old.setBz(yzd.getBz());
    old.setXgrYGid(bo.getXgrYGid());
    old.setXgrYGxm(bo.getXgrYGxm());
    old.setXgsj(bo.getXgsj());
    return (MZYZD)JPAUtils.save(old);
  }
  
  private void InitYZDMx(MZYZD yzd, YZDMXBase yzmx, MZYZDBo bo) {
    yzmx.setLsh(null);
    yzmx.setbRJBXXid(bo.getRegister().getBrjbxx().getId());
    yzmx.setRegisterLsh(bo.getRegister().getLsh());
    yzmx.setSfcqyz(DictConst.Int_0);
    if (yzmx.getYzsx() == null)
      yzmx.setYzsx(DictConst.Int_0); 
    if (IntegerUtils.isNullOrZero(yzmx.getJzKSid()).booleanValue())
      yzmx.setJzKSid(yzd.getJzKSid()); 
    if (yzmx.getZxKSid() == null)
      yzmx.setZxKSid(DictConst.Int_0); 
    yzmx.setShYGid(DictConst.Int_0);
    if (yzmx.getQj() == null)
      yzmx.setQj(yzmx.getDj()); 
    if (yzmx.getZt() == null)
      yzmx.setZt(DictConst.YZDMXZT_新开); 
    yzmx.setZxzt(DictConst.Int_0);
    if (yzmx.getKzYGid() == null) {
      yzmx.setKzYGid(bo.getXgrYGid());
      yzmx.setKzsj(bo.getXgsj());
    } 
    if (yzmx.getZrYGid() == null)
      yzmx.setZrYGid(yzmx.getKzYGid()); 
    yzmx.setLrrYGid(bo.getXgrYGid());
    yzmx.setLrsj(bo.getXgsj());
    yzmx.setXgsj(bo.getXgsj());
  }
  
  private MZYZDYPMX InitYZDYPMX(MZYZD yzd, MZYZDYPMX ypmx, MZYZDBo bo, List<MZYZDYPMX> oldYpmxList) {
    if (ypmx.getLsh() == null || ypmx.getLsh().intValue() < 1) {
      InitYZDMx(yzd, (YZDMXBase)ypmx, bo);
      return (MZYZDYPMX)JPAUtils.save(ypmx);
    } 
    MZYZDYPMX old = null;
    for (MZYZDYPMX temp : oldYpmxList) {
      if (temp.getLsh().equals(ypmx.getLsh())) {
        old = temp;
        break;
      } 
    } 
    if (old == null)
      ThrowException.runtime("emr.yzdmx.lsh.notFound", new Object[] { ypmx.getyZDlsh(), ypmx.getLsh() }); 
    old.setXgsj(bo.getXgsj());
    return (MZYZDYPMX)JPAUtils.save(old);
  }
  
  private MZYZDZLMX InitYZDZLMX(MZYZD yzd, MZYZDZLMX zlmx, MZYZDBo bo, List<MZYZDZLMX> oldZlmxList) {
    MZSSJL operation = null;
    if (zlmx.getLsh() == null || zlmx.getLsh().intValue() < 1) {
      InitYZDMx(yzd, (YZDMXBase)zlmx, bo);
      if (operation != null) {
        operation.setbRJBXXid(zlmx.getbRJBXXid());
        operation.setRegisterLsh(zlmx.getRegisterLsh());
        operation.setyZZXLsh(DictConst.Int_0);
        operation.setXgsj(bo.getXgsj());
        operation.setZt(DictConst.SSJL_申请);
        operation.setSqrYGid(zlmx.getKzYGid());
        operation.setSqksKSid(zlmx.getKzKSid());
        operation.setSqsj(zlmx.getKzsj());
        if (operation.getSskssj() == null && !StringUtils.isEmpty(zlmx.getZxsjfa()))
          operation.setSskssj(DateUtils.strToDateTime(zlmx.getZxsjfa())); 
        operation = (MZSSJL)JPAUtils.save(operation);
        zlmx.setzLSQDlsh(operation.getLsh());
      } 
      zlmx = (MZYZDZLMX)JPAUtils.save(zlmx);
      if (operation != null)
        operation.setyZDMXLsh(zlmx.getLsh()); 
      return zlmx;
    } 
    MZYZDZLMX old = null;
    for (MZYZDZLMX temp : oldZlmxList) {
      if (temp.getLsh().equals(zlmx.getLsh())) {
        old = temp;
        break;
      } 
    } 
    if (old == null)
      ThrowException.runtime("emr.yzdmx.lsh.notFound", new Object[] { zlmx.getyZDlsh(), zlmx.getLsh() }); 
    old.setXgsj(bo.getXgsj());
    return (MZYZDZLMX)JPAUtils.save(old);
  }
  
  private MZYZJJ InitYZDJJ(MZYZJJ src, MZYZDBo bo, List<MZYZJJ> oldZlmxList) {
    if (src.getLsh() == null || src.getLsh().intValue() < 1) {
      src.setRegisterLsh(bo.getRegisterLsh());
      src.setLsh(null);
      if (src.getZt() == null)
        src.setZt(Integer.valueOf(1)); 
      return (MZYZJJ)JPAUtils.save(src);
    } 
    MZYZJJ old = null;
    for (MZYZJJ temp : oldZlmxList) {
      if (temp.getLsh().equals(src.getLsh())) {
        old = temp;
        break;
      } 
    } 
    if (old == null)
      ThrowException.runtime("emr.yzdmx.lsh.notFound", new Object[] { src.getyZDlsh(), src.getLsh() }); 
    if (src.getZt() == null)
      old.setZt(src.getZt()); 
    old.setJjsj(bo.getXgsj());
    return (MZYZJJ)JPAUtils.save(old);
  }
  
  private MZYZZD InitYZZD(MZYZZD src, MZYZDBo bo, List<MZYZZD> oldYzzdList) {
    if (src.getLsh() == null || src.getLsh().intValue() < 1) {
      src.setLsh(null);
      src.setbRJBXXid(bo.getRegister().getBrjbxx().getId());
      src.setRegisterLsh(bo.getRegisterLsh());
      src.setLrrYGid(bo.getXgrYGid());
      src.setLrsj(bo.getXgsj());
      src.setXgsj(bo.getXgsj());
      return (MZYZZD)JPAUtils.save(src);
    } 
    MZYZZD old = null;
    for (MZYZZD temp : oldYzzdList) {
      if (temp.getLsh().equals(src.getLsh())) {
        old = temp;
        break;
      } 
    } 
    if (old == null)
      ThrowException.runtime("emr.yzdmx.lsh.notFound", new Object[] { src.getyZDlsh(), src.getLsh() }); 
    old.setXgsj(bo.getXgsj());
    return (MZYZZD)JPAUtils.save(old);
  }
  
  private void saveMedicalOrdersValidate(MZYZDBo bo) {
    for (MZYZD temp : bo.getYzd()) {
      if (temp.getCflx() == null)
        throw new RuntimeException("医嘱单【" + temp.getTitle() + "】,处方类型【cflx】为空."); 
      if (temp.getKdKSid() == null)
        throw new RuntimeException("医嘱单【" + temp.getTitle() + "】,开单科室【kdKSid】为空."); 
      if (temp.getKdrYGid() == null)
        throw new RuntimeException("医嘱单【" + temp.getTitle() + "】,开单医师【kdrYGid】为空."); 
    } 
    for (MZYZDYPMX temp : bo.getYpmx()) {
      if (temp.getKzKSid() == null)
        throw new RuntimeException("医嘱单【" + temp.getyZDlsh().toString() + "】,开嘱科室【kzKSid】为空."); 
    } 
  }
  
  public void updateMZGHD(MZYZDBo bo) {
    long yzdCount = 0L;
    boolean update = false;
    List<MZYZZD> yzd = JPAUtils.query("select a from MZYZZD a where a.bRJBXXid=?1 and a.registerLsh=?2 and a.zdbs>0 order by a.zdbs", new Object[] { bo
          .getRegister().getBrjbxx().getId(), bo.getRegisterLsh() });
    StringBuilder yzdStr = new StringBuilder();
    int yznrCount = 0;
    for (MZYZZD tmp : yzd) {
      String yznr = tmp.getZhmc();
      if (!StringUtils.isEmpty(yznr)) {
        yznr = yznr.trim();
        if (yzdStr.indexOf(yznr) == -1) {
          if (yznrCount > 0)
            yzdStr.append(","); 
          yzdStr.append(yznr);
          if (DictConst.Int_1.equals(tmp.getYz()))
            yzdStr.append("(疑诊)"); 
          yznrCount++;
        } 
      } 
    } 
    MZBLBD emr = (MZBLBD)JPAUtils.findOne(MZBLBD.class, bo.getRegisterLsh());
    if (emr == null) {
      emr = new MZBLBD();
      emr.setmZGHJLlsh(bo.getRegisterLsh());
      emr.setbRJBXXid(bo.getRegister().getBrjbxx().getId());
      emr.setBlwjsl(DictConst.Int_0);
      emr.setCfsl(DictConst.Int_0);
    } 
    emr.setZd(yzdStr.toString());
    JPAUtils.save(emr);
    if (IntegerUtils.isBitOn(bo.getFlag(), 1)) {
      yzdCount = JPAUtils.getCount(MZYZD.class, "a.bRJBXXid=?1 and a.registerLsh=?2 and a.zt>2 and a.jdlx<5", new Object[] { bo
            
            .getRegister().getBrjbxx().getId(), bo.getRegisterLsh() });
      update = true;
    } else if (IntegerUtils.isBitOn(bo.getFlag(), 0)) {
      yzdCount = JPAUtils.getCount(MZYZD.class, "a.bRJBXXid=?1 and a.registerLsh=?2 and a.zt>2", new Object[] { bo
            
            .getRegister().getBrjbxx().getId(), bo.getRegisterLsh() });
      update = true;
    } 
    if (update) {
      Integer sfgq;
      MZGHJL ghjl = bo.getRegister();
      boolean ghdzt = IntegerUtils.isBitOn(ghjl.getNhbz(), 8);
      if (yzdCount == 0L && ghdzt) {
        sfgq = DictConst.Int_1;
      } else if (yzdCount > 0L && !ghdzt) {
        sfgq = DictConst.Int_0;
      } else {
        return;
      } 
      if (IntegerUtils.isBitOff(bo.getFlag(), 4))
        ghjl = (MZGHJL)JPAUtils.findOne(MZGHJL.class, ghjl.getLsh()); 
      MZSFD mzsfd = (MZSFD)JPAUtils.findOne("select a from MZSFD a where a.djlx = 3 and a.zt=2 and a.brjbxx.id=?1 and a.mzghjl.lsh = ?2", new Object[] { ghjl
            .getBrjbxx().getId(), ghjl.getLsh() });
      if (yzdCount == 0L) {
        ghjl.setNhbz(Integer.valueOf(IntegerUtils.bitOff(ghjl.getNhbz(), 8)));
      } else {
        ghjl.setNhbz(Integer.valueOf(IntegerUtils.bitOn(ghjl.getNhbz(), 8)));
      } 
      JPAUtils.save(ghjl);
      if (mzsfd != null && !sfgq.equals(mzsfd.getSfgq())) {
        mzsfd.setSfgq(sfgq);
        JPAUtils.save(mzsfd);
      } 
    } 
  }
  
  public MZYZDBo saveMedicalOrders(MZYZDBo bo) {
    List<MZYZD> oldYzdList;
    List<MZYZDYPMX> oldYpmxList;
    List<MZYZDZLMX> oldZlmxList;
    List<MZYZJJ> oldYzjjList;
    bo.setSendRp(Boolean.valueOf(true));
    MZGHJL ghjl = (MZGHJL)JPAUtils.findOne(MZGHJL.class, bo.getRegisterLsh());
    if (ghjl == null)
      ThrowException.runtime("emr.register.lsh.notFound", new Object[] { bo.getRegisterLsh() }); 
    if (bo.getYzd() == null || bo.getYzd().size() == 0)
      ThrowException.runtime("emr.yzd.null", new Object[0]); 
    saveMedicalOrdersValidate(bo);
    bo.setRegister(ghjl);
    bo.setXgrYGid(LoginUser.getyGid());
    bo.setXgrYGxm(LoginUser.getXm());
    bo.setXgsj(new Date());
    MZYZD yzd = null;
    List<Integer> tempLshList = bo.getLsh(0);
    if (tempLshList.size() > 0) {
      bo._lsh = bo.getMax();
      oldYzdList = JPAUtils.findAll(MZYZD.class, tempLshList);
      for (int i5 = 0; i5 < oldYzdList.size(); i5++) {
        MZYZD oldYzd = oldYzdList.get(i5);
        if (oldYzd.getZt().equals(DictConst.YZDZT_已发送)) {
          yzd = bo.indexOf(oldYzd.getLsh());
          yzd.setLsh(Integer.valueOf(bo._lsh));
          yzd.setDh(oldYzd.getDh());
          bo._lsh--;
          cancelMedicalOrder(bo, oldYzdList.get(i5), yzd.getLsh(), false, false);
          oldYzdList.set(i5, null);
        } 
      } 
    } else {
      oldYzdList = Collections.emptyList();
    } 
    Map<Integer, MZYZD> yzdIds = new HashMap<>(bo.getYzd().size());
    bo.setYzdmxIds(new HashMap<>(bo.getYpmx().size() + bo.getZlmx().size()));
    Map<Integer, YZDMXBase> yzdmxIds = bo.getYzdmxIds();
    MZYZZLSQD zlsqd = null;
    MZYZZD newyzzd = null;
    for (int i = 0, len = bo.getYzd().size(); i < len; i++) {
      yzd = bo.getYzd().get(i);
      if (yzd.getLsh().intValue() < 0 && ghjl.getZt().equals(DictConst.GHZT_退号))
        ThrowException.runtime("emr.register.zt.cancel", new Object[] { ghjl.getbRJBXXmzh() }); 
      Integer tempLsh = yzd.getLsh();
      yzd = InitYZD(yzd, bo, oldYzdList);
      if (yzd.getZlsqd() == null) {
        yzd.setZlsqdLsh(DictConst.Int_0);
      } else {
        if (IntegerUtils.isNullOrZero(yzd.getZlsqd().getLsh()).booleanValue()) {
          zlsqd = new MZYZZLSQD();
          zlsqd.setLsh(yzd.getLsh());
          zlsqd.setbRJBXXid(yzd.getbRJBXXid());
          zlsqd.setRegisterLsh(yzd.getRegisterLsh());
          zlsqd.setSqdh(yzd.getLsh().toString());
          zlsqd.setSqrYGid(yzd.getKdrYGid());
          zlsqd.setSqrq(bo.getXgsj());
          zlsqd.setSqksKSid(yzd.getKdKSid());
          zlsqd.setZxksKSid(Integer.valueOf(0));
          zlsqd.setDycs(DictConst.Int_0);
          zlsqd.setTmdycs(DictConst.Int_0);
          zlsqd.setZt(DictConst.Int_0);
          zlsqd.setLrrYGid(bo.getXgrYGid());
          zlsqd.setLrsj(bo.getXgsj());
          yzd.setZlsqdLsh(yzd.getLsh());
        } else {
          zlsqd = (MZYZZLSQD)JPAUtils.findOne(MZYZZLSQD.class, yzd.getZlsqd().getLsh());
        } 
        zlsqd.setBlzy(yzd.getZlsqd().getBlzy());
        zlsqd.setTgjc(yzd.getZlsqd().getTgjc());
        zlsqd.setLczd(yzd.getZlsqd().getLczd());
        zlsqd.setLczdbm(yzd.getZlsqd().getLczdbm());
        zlsqd.setSqmd(yzd.getZlsqd().getSqmd());
        zlsqd.setXgrYGid(bo.getXgrYGid());
        zlsqd.setXgsj(bo.getXgsj());
        JPAUtils.save(zlsqd);
      } 
      bo.getYzd().set(i, yzd);
      if (tempLsh != null && tempLsh.intValue() > 0)
        JPAUtils.executeUpdate("udpate MZYZZD set zdbs = 0  where a.bRJBXXid = ?1 and a.registerLsh=?2 and a.zdbs>0 and a.yZDlsh=?3", new Object[] { bo
              .getRegister().getBrjbxx().getId(), bo.getRegisterLsh(), tempLsh }); 
      for (MZYZZD mZYZZD : bo.getYzzd()) {
        newyzzd = new MZYZZD();
        SpringBeanUtilsEx.copyIgnoreNullProperties(mZYZZD, newyzzd, new String[0]);
        newyzzd.setLsh(null);
        newyzzd.setyZDlsh(yzd.getLsh());
        newyzzd.setbRJBXXid(bo.getRegister().getBrjbxx().getId());
        newyzzd.setRegisterLsh(bo.getRegisterLsh());
        newyzzd.setLrrYGid(bo.getXgrYGid());
        newyzzd.setLrsj(bo.getXgsj());
        newyzzd.setXgsj(bo.getXgsj());
        JPAUtils.save(newyzzd);
      } 
      yzdIds.put(tempLsh, yzd);
    } 
    MZYZDYPMX ypmx = null;
    tempLshList = bo.getLsh(1);
    if (tempLshList.size() == 0) {
      oldYpmxList = Collections.emptyList();
    } else {
      oldYpmxList = JPAUtils.findAll(MZYZDYPMX.class, tempLshList);
    } 
    for (int j = 0, k = bo.getYpmx().size(); j < k; j++) {
      ypmx = bo.getYpmx().get(j);
      yzd = yzdIds.get(ypmx.getyZDlsh());
      ypmx.setYzdOrder((YZDBase)yzd);
      Integer tempLsh = ypmx.getLsh();
      if (ypmx.getyZDlsh().intValue() < 0)
        ypmx.setyZDlsh(yzd.getLsh()); 
      ypmx = InitYZDYPMX(yzd, ypmx, bo, oldYpmxList);
      bo.getYpmx().set(j, ypmx);
      if (ypmx.getChargeItem() == null)
        if (DictConst.XMLB_材料.equals(ypmx.getXmlx())) {
          ypmx.setChargeItem((ChargeItem)FRPubService.findOneCLMLB(ypmx.getXmid(), Boolean.valueOf(false), new String[0]));
        } else {
          ypmx.setChargeItem((ChargeItem)FRPubService.findOneYPMLB(ypmx.getXmid(), Boolean.valueOf(false), new String[0]));
        }  
      yzdmxIds.put(tempLsh, ypmx);
    } 
    MZYZDZLMX zlmx = null;
    tempLshList = bo.getLsh(2);
    if (tempLshList.size() == 0) {
      oldZlmxList = Collections.emptyList();
    } else {
      oldZlmxList = JPAUtils.findAll(MZYZDZLMX.class, tempLshList);
    } 
    for (int m = 0, n = bo.getZlmx().size(); m < n; m++) {
      zlmx = bo.getZlmx().get(m);
      yzd = yzdIds.get(ypmx.getyZDlsh());
      zlmx.setYzdOrder((YZDBase)yzd);
      Integer tempLsh = zlmx.getLsh();
      if (zlmx.getyZDlsh().intValue() < 0)
        zlmx.setyZDlsh(yzd.getLsh()); 
      zlmx = InitYZDZLMX(yzd, zlmx, bo, oldZlmxList);
      if (zlmx.getChargeItem() == null)
        zlmx.setChargeItem((ChargeItem)FRPubService.findOneSFXMB(zlmx.getXmid(), Boolean.valueOf(false), new String[0])); 
      bo.getZlmx().set(m, zlmx);
      yzdmxIds.put(tempLsh, zlmx);
    } 
    for (MZYZDYPMX temp : bo.getYpmx()) {
      if (temp.getGlYZDMXlsh() != null && temp.getGlYZDMXlsh().intValue() < 0) {
        temp.setGlYZDMX(yzdmxIds.get(temp.getGlYZDMXlsh()));
        temp.setGlYZDMXlsh(temp.getGlYZDMX().getLsh());
      } 
    } 
    for (MZYZDZLMX temp : bo.getZlmx()) {
      if (temp.getGlYZDMXlsh() != null && temp.getGlYZDMXlsh().intValue() < 0) {
        temp.setGlYZDMX(yzdmxIds.get(temp.getGlYZDMXlsh()));
        temp.setGlYZDMXlsh(temp.getGlYZDMX().getLsh());
      } 
    } 
    MZYZZD yzzd = null;
    List<MZYZZD> oldYzzdList = JPAUtils.query("select a from MZYZZD a where a.bRJBXXid = ?1 and a.registerLsh=?2 and a.zdbs>0 and a.yZDlsh=0", new Object[] { bo
          .getRegister().getBrjbxx().getId(), bo.getRegisterLsh() });
    for (int i1 = 0, i2 = bo.getYzzd().size(); i1 < i2; i1++) {
      yzzd = bo.getYzzd().get(i1);
      if (yzzd.getyZDlsh().intValue() < 0)
        yzzd.setyZDlsh(((MZYZD)yzdIds.get(yzzd.getyZDlsh())).getLsh()); 
      yzzd = InitYZZD(yzzd, bo, oldYzzdList);
      bo.getYzzd().set(i1, yzzd);
    } 
    for (MZYZZD temp : oldYzzdList) {
      if (!temp.getXgsj().equals(bo.getXgsj())) {
        temp.setScrYGid(bo.getXgrYGid());
        temp.setScsj(bo.getXgsj());
        temp.setZdbs(DictConst.Int_0);
        JPAUtils.save(temp);
      } 
    } 
    MZYZJJ yzjj = null;
    tempLshList = bo.getLsh(4);
    if (tempLshList.size() == 0) {
      oldYzjjList = Collections.emptyList();
    } else {
      oldYzjjList = JPAUtils.findAll(MZYZJJ.class, bo.getLsh(4));
    } 
    YPCLMLB ypml = null;
    SFXMB sfml = null;
    SelectedChargeItemsInfo itemInfo = null;
    SelectedChargeItemsInfo.ItemInfo newItem = null;
    Integer oldExecDept = null;
    for (int i3 = 0, i4 = bo.getYzjj().size(); i3 < i4; i3++) {
      yzjj = bo.getYzjj().get(i3);
      yzjj.setYzdmx(yzdmxIds.get(yzjj.getyZDMXlsh()));
      if (yzjj.getYzdmx() == null) {
        oldExecDept = null;
        yzjj.setyZDMXlsh(DictConst.Int_0);
        yzjj.setyZDlsh(DictConst.Int_0);
      } else {
        yzjj.setyZDMXlsh(yzjj.getYzdmx().getLsh());
        yzjj.setyZDlsh(yzjj.getYzdmx().getyZDlsh());
        oldExecDept = yzjj.getZxKSid();
        yzjj.setZxKSid(yzjj.getYzdmx().getZxKSid());
      } 
      yzjj.setJjsj(bo.getXgsj());
      yzjj = InitYZDJJ(yzjj, bo, oldYzjjList);
      if (yzjj.getXmlx().equals(DictConst.XMLB_药品)) {
        YPMLB yPMLB = FRPubService.findOneYPMLB(yzjj.getXmid(), Boolean.valueOf(true), new String[0]);
        if (DictConst.Int_0.equals(yPMLB.getSjms()))
          ThrowException.runtime("emr.xm.date", new Object[] { yPMLB.getMc(), yPMLB.getBm() }); 
        yzjj.setChargeItem((ChargeItem)yPMLB);
        if (DictConst.Int_2.equals(yPMLB.getSjms())) {
          if (itemInfo == null) {
            itemInfo = new SelectedChargeItemsInfo();
            itemInfo.setItemsInfo(new ArrayList(1));
            newItem = new SelectedChargeItemsInfo.ItemInfo();
            itemInfo.getItemsInfo().add(newItem);
            itemInfo.setbRFBid(bo.getRegister().getbRFBid());
            itemInfo.setkSid(bo.getRegister().getJzksidKSid());
            itemInfo.setyLFWLXbh(DictConst.YLFWLX_门诊);
          } 
          newItem.setXmid(yzjj.getXmid());
          newItem.setXmlb(yzjj.getXmlx());
          newItem.setZxksid(yzjj.getZxKSid());
          if (logger.isDebugEnabled())
            logger.debug(FRApplication.getJsonMapper().toJson(newItem)); 
          itemInfo = this.itemBillService.getChargeItemInfo(itemInfo);
          if (newItem.getMzlsbz().equals(BigDecimal.ONE)) {
            yzjj.setDj(newItem.getDj());
          } else {
            yzjj.setDj(BigDecimalUtils.multiply(newItem.getDj(), newItem.getMzlsbz(), new int[] { 4 }));
          } 
          yzjj.setSjpch(newItem.getKcpclsh());
          yzjj.setQj(yzjj.getDj());
          yzjj.setYj(yzjj.getDj());
        } 
      } else if (yzjj.getXmlx().equals(DictConst.XMLB_收费项目)) {
        sfml = FRPubService.findOneSFXMB(yzjj.getXmid(), Boolean.valueOf(true), new String[0]);
        yzjj.setChargeItem((ChargeItem)sfml);
        if ("J-1".equals(yzjj.getChargeItem().getyLFWXMTXbh()) && 
          IntegerUtils.isBitOff(bo.getRegister().getNhbz(), 16))
          bo.getRegister().setNhbz(Integer.valueOf(IntegerUtils.bitOn(bo.getRegister().getNhbz(), 16))); 
        if (oldExecDept != null)
          yzjj.setZxKSid(oldExecDept); 
      } else if (yzjj.getXmlx().equals(DictConst.XMLB_材料)) {
        CLMLB cLMLB = FRPubService.findOneCLMLB(yzjj.getXmid(), Boolean.valueOf(true), new String[0]);
        yzjj.setChargeItem((ChargeItem)cLMLB);
        if (DictConst.Str_1.equals(FRApplication.getParamValue(Integer.valueOf(228))) && DictConst.Int_2.equals(cLMLB.getSjms())) {
          if (itemInfo == null) {
            itemInfo = new SelectedChargeItemsInfo();
            itemInfo.setItemsInfo(new ArrayList(1));
            newItem = new SelectedChargeItemsInfo.ItemInfo();
            itemInfo.getItemsInfo().add(newItem);
            itemInfo.setbRFBid(bo.getRegister().getbRFBid());
            itemInfo.setkSid(bo.getRegister().getJzksidKSid());
            itemInfo.setyLFWLXbh(DictConst.YLFWLX_门诊);
          } 
          newItem.setXmid(yzjj.getXmid());
          newItem.setXmlb(yzjj.getXmlx());
          newItem.setZxksid(yzjj.getZxKSid());
          if (logger.isDebugEnabled())
            logger.debug(FRApplication.getJsonMapper().toJson(newItem)); 
          itemInfo = this.itemBillService.getChargeItemInfo(itemInfo);
          if (newItem.getMzlsbz().equals(BigDecimal.ONE)) {
            yzjj.setDj(newItem.getDj());
          } else {
            yzjj.setDj(BigDecimalUtils.multiply(newItem.getDj(), newItem.getMzlsbz(), new int[] { 4 }));
          } 
          yzjj.setSjpch(newItem.getKcpclsh());
          yzjj.setQj(yzjj.getDj());
          yzjj.setYj(yzjj.getDj());
        } 
      } 
      if (yzjj.getChargeItem().getYxsj().before(bo.getXgsj()))
        ThrowException.runtime("emr.xm.date", new Object[] { yzjj.getChargeItem().getMc(), yzjj.getChargeItem().getBm() }); 
      if (yzjj.getQj() == null)
        yzjj.setQj(yzjj.getDj()); 
      if (yzjj.getYj() == null)
        yzjj.setYj(yzjj.getDj()); 
      bo.getYzjj().set(i3, yzjj);
    } 
    if (!IntegerUtils.isBitValueOn(ghjl.getNhbz(), Integer.valueOf(64)))
      ghjl.setNhbz(Integer.valueOf(IntegerUtils.bitValueOn(ghjl.getNhbz(), 64))); 
    JPAUtils.save(bo.getYzd());
    JPAUtils.save(bo.getYpmx());
    JPAUtils.save(bo.getZlmx());
    JPAUtils.save(bo.getYzjj());
    JPAUtils.save(bo.getYzzd());
    if (bo.getSendRp().booleanValue()) {
      bo.setOrderBzMode(emrParams.param_医嘱计价_备注内容());
      bo.setOrderSplitMode(emrParams.param_医嘱单生成收费单规则());
      bo.setIsCheckClKuCun(Boolean.valueOf(DictConst.Int_0.equals(emrParams.param_材料是否不限制库存())));
      OutChargeBillsInfo bill = OutIndexChargeBillService.CreateBillWithExecDept(bo);
      Map<Integer, MZYZCS> copyBillMap = null;
      if (bill != null) {
        List<OutChargeBillsInfo> source = new ArrayList<>(1);
        source.add(bill);
        List<MZSFD> billResult = this.billService.save(source);
        copyBillMap = new HashMap<>();
        updateYzdmxSfdLsh(bo, billResult, copyBillMap);
      } 
      saveMedicalOrdersYZCS(bo, copyBillMap);
    } 
    cleanMZYZDBo(bo);
    return bo;
  }
  
  public MZYZD medicalordersBatch(MZYZD src) {
    MZYZD dest = (MZYZD)JPAUtils.findOne(MZYZD.class, src.getLsh());
    SpringBeanUtilsEx.copyIgnoreNullProperties(src, dest, new String[] { "lsh", "version" });
    return dest;
  }
  
  private void updateYzdmxSfdLsh(MZYZDBo bo, List<MZSFD> billResult, Map<Integer, MZYZCS> copyBillMap) {
    if (IntegerUtils.isBitOn(bo.getFlag(), 3)) {
      List<Integer> billIds = new ArrayList<>(billResult.size());
      for (MZSFD sfd : billResult)
        billIds.add(sfd.getLsh()); 
      bo.setBillIds(billIds);
    } 
    Collection<YZDMXBase> yzdmxList = bo.getYzdmxIds().values();
    Map<Integer, YZDMXBase> ydmxIds = new HashMap<>();
    for (YZDMXBase temp : yzdmxList)
      ydmxIds.put(temp.getLsh(), temp); 
    YZDMXBase yzdmxBase = null;
    MZYZCS copy = null;
    for (MZSFD sfd : billResult) {
      if (sfd.getSfxmmx() != null)
        for (MZSFDSFXMMX temp : sfd.getSfxmmx()) {
          yzdmxBase = ydmxIds.get(temp.getmZYZDMXlsh());
          if (yzdmxBase != null) {
            copy = copyBillMap.get(yzdmxBase.getLsh());
            if (copy == null) {
              copy = new MZYZCS();
              copy.setJe(temp.getYsje());
              copy.setDytm(Integer.valueOf(1));
              copyBillMap.put(temp.getmZYZDMXlsh(), copy);
            } else {
              copy.setDytm(Integer.valueOf(copy.getDytm().intValue() + 1));
              copy.setJe(temp.getYsje().add(copy.getJe()));
            } 
            if (yzdmxBase.getXmid().equals(((SFXMB)temp.getChargeItem()).getId())) {
              yzdmxBase.setQj(temp.getQj());
              yzdmxBase.setDj(temp.getDj());
              copy.setsFDlsh(sfd.getLsh());
              copy.setYxrq(temp.getXfjzsj());
              copy.setsFDSFXMMXlsh(temp.getLsh());
            } 
          } 
        }  
    } 
  }
  
  private void medicalOrdersValidate(OutRpOrdersBo bo) {
    if (bo.getSendRp() == null)
      bo.setSendRp(Boolean.valueOf(true)); 
    if (IntegerUtils.isNullOrZero(bo.getRegisterLsh()).booleanValue())
      ThrowException.dataInputError(new String[] { "emr.register.lsh.null" }); 
    MZGHJL ghjl = (MZGHJL)JPAUtils.findOne(MZGHJL.class, bo.getRegisterLsh());
    if (ghjl == null)
      ThrowException.runtime("emr.register.lsh.notFound", new Object[] { bo.getRegisterLsh() }); 
    if (bo.getOrders() == null || bo.getOrders().size() == 0)
      ThrowException.runtime("emr.yzd.null", new Object[0]); 
    bo.setModifyDate(new Date());
    bo.setModifyEmpId(LoginUser.getyGid());
    bo.setModifyEmpName(LoginUser.getXm());
  }
  
  private void saveMedicalYZD(MZYZD yzd) {
    if (yzd.getCflx() == null)
      throw new RuntimeException("医嘱单【" + yzd.getTitle() + "】,处方类型【cflx】为空."); 
    if (yzd.getKdKSid() == null)
      throw new RuntimeException("医嘱单【" + yzd.getTitle() + "】,开单科室【kdKSid】为空."); 
    if (yzd.getKdrYGid() == null)
      throw new RuntimeException("医嘱单【" + yzd.getTitle() + "】,开单医师【kdrYGid】为空."); 
    if (yzd.getLsh() == null || yzd.getLsh().intValue() < 1)
      yzd.setLsh(null); 
  }
  
  private void saveMedicalOrders_YZZD(OutRpOrdersBo bo, List<MZYZZD> src, Integer yzdLsh, Boolean isPublic) {
    MZGHJL register = bo.getRegister();
    List<MZYZZD> oldYzzdList = null;
    for (int i = 0, len = src.size(); i < len; i++) {
      MZYZZD yzzd = src.get(i);
      if (yzzd.getLsh() == null || yzzd.getLsh().intValue() < 1) {
        yzzd.setLsh(null);
        yzzd.setyZDlsh(yzdLsh);
        yzzd.setbRJBXXid(register.getBrjbxx().getId());
        yzzd.setRegisterLsh(register.getLsh());
        yzzd.setLrrYGid(bo.getModifyEmpId());
        yzzd.setLrsj(bo.getModifyDate());
        yzzd.setXgsj(bo.getModifyDate());
        yzzd = (MZYZZD)JPAUtils.save(yzzd);
      } else {
        if (oldYzzdList == null)
          oldYzzdList = JPAUtils.query("select a from MZYZZD a where a.bRJBXXid = ?1 and a.registerLsh = ?2 and a.yZDlsh = ?3", new Object[] { register
                .getBrjbxx().getId(), register.getLsh(), yzdLsh }); 
        MZYZZD old = null;
        for (MZYZZD temp : oldYzzdList) {
          if (temp.getLsh().equals(yzzd.getLsh())) {
            old = temp;
            break;
          } 
        } 
        if (old == null)
          ThrowException.runtime("emr.yzdmx.lsh.notFound", new Object[] { yzzd.getyZDlsh(), yzzd.getLsh() }); 
        old.setXh(yzzd.getXh());
        old.setZdzt(yzzd.getZdzt());
        old.setZdxz(yzzd.getZdxz());
        if (yzzd.getYz() != null)
          old.setYz(yzzd.getYz()); 
        old.setZdlx(yzzd.getZdlx());
        old.setXgsj(bo.getModifyDate());
        if (yzzd.getBz() != null)
          old.setBz(yzzd.getBz()); 
        yzzd = (MZYZZD)JPAUtils.save(old);
      } 
      src.set(i, yzzd);
    } 
    if (oldYzzdList != null)
      for (MZYZZD temp : oldYzzdList) {
        if (!temp.getXgsj().equals(bo.getModifyDate())) {
          temp.setScrYGid(bo.getModifyEmpId());
          temp.setScsj(bo.getModifyDate());
          temp.setZdbs(DictConst.Int_0);
          JPAUtils.save(temp);
        } 
      }  
  }
  
  public OutRpOrdersBo saveMedicalOrders(OutRpOrdersBo bo) {
    medicalOrdersValidate(bo);
    Boolean isPublicZD = Boolean.valueOf(IntegerUtils.isBitOff(bo.getFlag(), 3));
    for (MZYZD temp : bo.getOrders()) {
      saveMedicalYZD(temp);
      if (!isPublicZD.booleanValue())
        saveMedicalOrders_YZZD(bo, temp.getYzzd(), temp.getLsh(), Boolean.valueOf(false)); 
      if (bo.getSendRp().booleanValue());
    } 
    if (isPublicZD.booleanValue())
      saveMedicalOrders_YZZD(bo, bo.getYzzd(), DictConst.Int_0, Boolean.valueOf(true)); 
    return bo;
  }
  
  private void cleanMZYZDBo(MZYZDBo src) {
    if (src.getYzjj() != null)
      for (MZYZJJ temp : src.getYzjj()) {
        temp.updateSfyxbj();
        temp.setYzdmx(null);
      }  
  }
  
  private void saveMedicalOrdersYZCS(MZYZDBo src, Map<Integer, MZYZCS> copyBillMap) {
    for (MZYZDYPMX temp : src.getYpmx())
      saveMedicalOrdersYZCSItem(src, (YZDMXBase)temp, copyBillMap.get(temp.getLsh()), false); 
    for (MZYZDZLMX temp : src.getZlmx())
      saveMedicalOrdersYZCSItem(src, (YZDMXBase)temp, copyBillMap.get(temp.getLsh()), true); 
  }
  
  private void saveMedicalOrdersYZCSItem(MZYZDBo src, YZDMXBase yzdmx, MZYZCS copyBill, boolean isZlyz) {
    if (yzdmx.getZt().compareTo(DictConst.YZDMXZT_新开) < 0)
      ThrowException.runtime("emr.yzd.zt.name." + yzdmx.getZt().toString(), new Object[0]); 
    if (yzdmx.getZt().compareTo(DictConst.YZDMXZT_新开) > 0)
      ThrowException.runtime("emr.yzd.zt.name." + yzdmx.getZt().toString(), new Object[0]); 
    yzdmx.setZt(DictConst.YZDMXZT_停止);
    yzdmx.setTzysYGid(src.getXgrYGid());
    yzdmx.setTzsj(src.getXgsj());
    if (!isZlyz || yzdmx.getyLFWXMTXbh().equals(DictConst.YLFWXMTX_中药方剂)) {
      yzdmx.setZxzt(DictConst.Int_2);
      return;
    } 
    MZYZCS yzcs = new MZYZCS();
    yzcs.copyFromYZMX(yzdmx);
    yzcs.setLrly(DictConst.Int_0);
    yzcs.setsFDlsh(copyBill.getsFDlsh());
    yzcs.setsFDSFXMMXlsh(copyBill.getsFDSFXMMXlsh());
    yzcs.setJe(copyBill.getJe());
    yzcs.setYxrq(copyBill.getYxrq());
    yzcs.setXmlx(DictConst.XMLB_收费项目);
    if (yzcs.getsFDlsh() == null)
      yzcs.setsFDlsh(DictConst.Int_0); 
    if (yzcs.getsFDSFXMMXlsh() == null)
      yzcs.setsFDSFXMMXlsh(DictConst.Int_0); 
    yzcs = (MZYZCS)JPAUtils.save(yzcs);
  }
  
  @Transactional(readOnly = true)
  public MZYZDMX getOrderDetail(Integer lsh, Integer xmlx) {
    MZYZDMX result;
    if (DictConst.XMLB_诊疗.equals(xmlx) || DictConst.XMLB_收费项目.equals(xmlx)) {
      result = (MZYZDMX)JPAUtils.findOne(MZYZDZLMX.class, lsh);
    } else {
      result = (MZYZDMX)JPAUtils.findOne(MZYZDYPMX.class, lsh);
    } 
    if (result == null) {
      result = new MZYZDMX();
      result.setLsh(Integer.valueOf(0));
    } else {
      MZGHJL register = (MZGHJL)JPAUtils.findOne(MZGHJL.class, result.getRegisterLsh());
      result.setRegister(register);
    } 
    this.emrCommonService.fetchPropsYZDMXChargeItem((YZDMXBase)result);
    return result;
  }
  
  public YZDMXBase deleteMedicalOrderDetail(Integer lsh, Integer xmlx) {
    if (xmlx == null)
      ThrowException.dataInputError(new String[] { "xmlx" }); 
    YZDMXBase result = null;
    if (xmlx.equals(DictConst.Int_4)) {
      result = (YZDMXBase)JPAUtils.findOne(MZYZDZLMX.class, lsh);
    } else {
      result = (YZDMXBase)JPAUtils.findOne(MZYZDYPMX.class, lsh);
    } 
    if (result == null)
      ThrowException.runtime("emr.yzdmx.lsh.notFound", new Object[] { "", lsh }); 
    if (result.getZt().compareTo(DictConst.YZDMXZT_新开) < 0)
      ThrowException.runtime("emr.yzd.delete.error", new Object[] { result.getYznr(), 
            SpringApplicationContext.getMessage("emr.yzd.zt.name." + result.getZt().toString(), new Object[0]) }); 
    if (result.getZt().compareTo(DictConst.YZDMXZT_启用) > 0)
      ThrowException.runtime("emr.yzd.delete.error", new Object[] { result.getYznr(), 
            SpringApplicationContext.getMessage("emr.yzd.zt.name." + result.getZt().toString(), new Object[0]) }); 
    MZYZD yzd = (MZYZD)JPAUtils.findOne(MZYZD.class, result.getyZDlsh());
    if (yzd == null)
      ThrowException.runtime("emr.yzd.lsh.notFound", new Object[] { result.getyZDlsh() }); 
    if (yzd.getZt().equals(DictConst.YZDZT_已收费))
      ThrowException.runtime("emr.yzd.zt.4", new Object[] { yzd.getDh() }); 
    Date now = new Date();
    if (xmlx.equals(DictConst.Int_4)) {
      yzd.setZlsl(Integer.valueOf(yzd.getZlsl().intValue() - 1));
    } else if (xmlx.equals(DictConst.Int_1)) {
      yzd.setYpsl(Integer.valueOf(yzd.getYpsl().intValue() - 1));
    } else if (xmlx.equals(DictConst.Int_3)) {
      yzd.setClsl(Integer.valueOf(yzd.getClsl().intValue() - 1));
    } 
    List<MZYZJJ> yzjj = JPAUtils.query("select a from MZYZJJ a where a.yZDMXlsh=?1 and a.zt=1", new Object[] { result.getLsh() });
    for (MZYZJJ temp : yzjj) {
      temp.setZt(DictConst.Int_0);
      temp.setJjsj(now);
    } 
    JPAUtils.save(yzjj);
    yzd.setXgrYGid(LoginUser.getyGid());
    yzd.setXgrYGxm(LoginUser.getXm());
    yzd.setXgsj(now);
    result.setXgsj(now);
    if (!yzd.getZt().equals(DictConst.YZDZT_已发送) || yzjj.size() > 0);
    result.setZt(DictConst.YZDMXZT_删除);
    JPAUtils.save(result);
    JPAUtils.save(yzd);
    return result;
  }
  
  public void updateCharges(List<MZYZJJ> src) {
    MZYZD yzd = (MZYZD)JPAUtils.findOne(MZYZD.class, ((MZYZJJ)src.get(0)).getyZDlsh());
    if (yzd == null)
      ThrowException.dataInputError(new String[] { "zyd.lsh=" + ((MZYZJJ)src.get(0)).getyZDlsh().toString() }); 
  }
  
  @Transactional(readOnly = true)
  public MZYZD getMedicalOrderByLsh(Integer lsh, String dh, Integer yzdmxLsh, Integer flag) {
    MZYZD result = null;
    if (IntegerUtils.isNullOrZero(lsh).booleanValue()) {
      if (StringUtils.isEmpty(dh)) {
        if (IntegerUtils.isNullOrZero(yzdmxLsh).booleanValue())
          return new MZYZD(); 
        MZYZDMX ypmx = (MZYZDMX)JPAUtils.findOne(MZYZDYPMX.class, yzdmxLsh);
        if (ypmx == null)
          ypmx = (MZYZDMX)JPAUtils.findOne(MZYZDZLMX.class, yzdmxLsh); 
        if (ypmx == null)
          return new MZYZD(); 
        result = (MZYZD)JPAUtils.findOne(MZYZD.class, ypmx.getyZDlsh());
      } else {
        result = (MZYZD)JPAUtils.findOne("select a from MZYZD a where a.zt>1 and a.dh = ?1 ", new Object[] { dh });
      } 
    } else {
      result = (MZYZD)JPAUtils.findOne(MZYZD.class, lsh);
    } 
    if (result == null)
      return new MZYZD(); 
    if (DictConst.Int_0.equals(flag))
      return result; 
    if (IntegerUtils.isBitOn(flag, 15) && !IntegerUtils.isNullOrZero(result.getZlsqdLsh()).booleanValue()) {
      MZYZZLSQD requestOrder = (MZYZZLSQD)JPAUtils.findOne(MZYZZLSQD.class, result.getZlsqdLsh());
      result.setZlsqd((YZZLSQDBase)requestOrder);
    } 
    if (IntegerUtils.isBitOn(flag, 8)) {
      MZGHJL register = (MZGHJL)JPAUtils.findOne(MZGHJL.class, result.getRegisterLsh());
      result.setRegister(register);
      if (register != null) {
        if (IntegerUtils.isBitOn(flag, 9))
          register.getMzghjlfb().getLxr(); 
        if (IntegerUtils.isBitOn(flag, 10) && !IntegerUtils.isNullOrZero(register.getyBJGid()).booleanValue()) {
          List<YBMZGHJL> ybmzghjlList = JPAUtils.queryTop("select a from YBMZGHJL a where a.zt > 0 and a.bRJBXXid = ?1 and a.mZGHJLlsh = ?2 order by a.jlly", null, 1, new Object[] { register
                .getBrjbxx().getId(), register.getLsh() });
          register.setYbmzghjl(ybmzghjlList.iterator().hasNext() ? ybmzghjlList.iterator().next() : null);
        } 
        if (IntegerUtils.isBitOn(flag, 11))
          register.getBrjbxx().getBah(); 
        if (IntegerUtils.isBitOn(flag, 12)) {
          MZBLBD home = (MZBLBD)JPAUtils.findOne(MZBLBD.class, register.getLsh());
          register.setHomePage(home);
        } 
        if (IntegerUtils.isBitOn(flag, 14)) {
          HYZH vip = (HYZH)JPAUtils.findOne(HYZH.class, register.getBrjbxx().getId());
          register.getBrjbxx().setVip(vip);
        } 
      } 
      result.setBrjbxx(null);
    } 
    if (!IntegerUtils.isNullOrZero(result.getZdsl()).booleanValue() && IntegerUtils.isBitOn(flag, 4)) {
      List<MZYZZD> zdList = JPAUtils.query("select a from MZYZZD a where a.bRJBXXid=?1 and a.registerLsh=?2 and a.yZDlsh=?3 and a.zdbs>0 order by a.xh ", new Object[] { result
            .getbRJBXXid(), result.getRegisterLsh(), result.getLsh() });
      result.setYzzd(zdList);
    } else {
      result.setYzzd(Collections.emptyList());
    } 
    List<MZYZDMX> yzdmxLs = new ArrayList<>(result.getZlsl().intValue() + result.getClsl().intValue() + result.getYpsl().intValue());
    result.setDetails(yzdmxLs);
    if (result.getZlsl().intValue() > 0) {
      List<MZYZDZLMX> zlmx = this.emrCommonService.getMZYzdZLMX(result, false, IntegerUtils.isBitOn(flag, 1));
      yzdmxLs.addAll(zlmx);
    } 
    if (result.getClsl().intValue() > 0 || result.getYpsl().intValue() > 0) {
      List<MZYZDYPMX> ypmx = this.emrCommonService.getMZYzdYPMX(result, false, IntegerUtils.isBitOn(flag, 2));
      yzdmxLs.addAll(ypmx);
    } 
    for (MZYZDMX temp : yzdmxLs)
      temp.setRegister(null); 
    if (IntegerUtils.isBitOn(flag, 13)) {
      List<MZYZCS> yzcs = JPAUtils.query("select a from MZYZCS a where a.bRJBXXid=?1 and a.registerLsh=?2 and a.yZDlsh=?3 and a.scbj<>1", new Object[] { result
            .getbRJBXXid(), result.getRegisterLsh(), result.getLsh() });
      for (MZYZCS temp : yzcs) {
        temp.setYzdmx(null);
        temp.setBrjbxx(null);
        temp.setsFDSFXMMX(null);
      } 
      result.setYzcs(yzcs);
    } 
    if (IntegerUtils.isBitOn(flag, 0)) {
      List<MZSFDSFXMMX> sfxmList = JPAUtils.query("select a from MZSFDSFXMMX a where a.brjbxx.id=?1 and a.mZGHJLlsh=?2 and a.zt>1 and a.mzsfd.yZDlsh=?3", new Object[] { result
            
            .getbRJBXXid(), result.getRegisterLsh(), result.getLsh() });
      List<MZSFDYPMX> ypList = JPAUtils.query("select a from MZSFDYPMX a where a.brjbxx.id=?1 and a.mZGHJLlsh=?2 and a.zt>1 and a.mzsfd.yZDlsh=?3", new Object[] { result
            
            .getbRJBXXid(), result.getRegisterLsh(), result.getLsh() });
      List<MZSFDCLMX> clList = JPAUtils.query("select a from MZSFDCLMX a where a.brjbxx.id=?1 and a.mZGHJLlsh=?2 and a.zt>1 and a.mzsfd.yZDlsh=?3", new Object[] { result
            
            .getbRJBXXid(), result.getRegisterLsh(), result.getLsh() });
      for (MZSFDSFXMMX temp : sfxmList)
        ((SFXMB)temp.getChargeItem()).getMc(); 
      for (MZSFDYPMX temp : ypList)
        ((YPMLB)temp.getChargeItem()).getMc(); 
      for (MZSFDCLMX temp : clList)
        ((CLMLB)temp.getChargeItem()).getMc(); 
      List<MZSFDMX> charges = new ArrayList<>(sfxmList.size() + ypList.size() + clList.size());
      charges.addAll(sfxmList);
      charges.addAll(ypList);
      charges.addAll(clList);
      result.setCharges(charges);
    } 
    return result;
  }
  
  public MZYZD reviewMedicalOrder(MZYZD src) {
    if (src == null || IntegerUtils.isNullOrZero(src.getLsh()).booleanValue())
      return src; 
    MZYZD dest = (MZYZD)JPAUtils.findOne(MZYZD.class, src.getLsh());
    if (dest != null) {
      if (IntegerUtils.isNullOrZero(src.getSfysYGid()).booleanValue()) {
        dest.setSfysYGid(LoginUser.getyGid());
      } else {
        dest.setSfysYGid(src.getSfysYGid());
      } 
      dest.setSfsj(new Date());
      dest.setSfjg(src.getSfjg());
      dest.setXgsj(dest.getSfsj());
      if (IntegerUtils.isBitOn(src.getBzw(), 0)) {
        dest.setBzw(Integer.valueOf(IntegerUtils.bitOn(src.getBzw(), 0)));
      } else if (IntegerUtils.isBitOn(src.getBzw(), 1)) {
        dest.setBzw(Integer.valueOf(IntegerUtils.bitOn(src.getBzw(), 1)));
      } 
    } 
    return dest;
  }
  
  private void cancelMedicalOrder(MZYZDBo bo, MZYZD yzd, Integer newYzdLsh, boolean cancel, boolean backRate) {
    if (DictConst.YZDZT_删除.equals(yzd.getZt()))
      ThrowException.runtime("emr.yzd.zt.0", new Object[] { yzd.getLsh() }); 
    if (DictConst.YZDZT_作废.equals(yzd.getZt()))
      ThrowException.runtime("emr.yzd.zt.1", new Object[] { yzd.getLsh() }); 
    if (cancel) {
      if (yzd.getZt().compareTo(DictConst.YZDZT_已收费) < 0)
        ThrowException.runtime("emr.yzd.zt." + yzd.getZt().toString(), new Object[] { yzd.getLsh() }); 
      if (backRate) {
        List<MZSFD> sfd = JPAUtils.query("select a from MZSFD a where a.brjbxx.id=?1 and a.mzghjl.lsh=?2 and a.yZDlsh=?3", new Object[] { yzd
              .getbRJBXXid(), yzd
              .getRegisterLsh(), yzd
              .getLsh() });
        if (sfd.size() > 0) {
          List<Integer> ids = new ArrayList<>(sfd.size());
          for (MZSFD temp : sfd)
            ids.add(temp.getLsh()); 
          this.outApi.vipRefund(yzd.getbRJBXXid(), ids);
        } 
      } 
    } else {
      if (yzd.getZt().compareTo(DictConst.YZDZT_已收费) >= 0)
        ThrowException.runtime("emr.yzd.zt." + yzd.getZt().toString(), new Object[] { yzd.getLsh() }); 
      List<MZSFD> sfd = JPAUtils.query("select a from MZSFD a where a.brjbxx.id=?1 and a.mzghjl.lsh=?2 and a.yZDlsh=?3", new Object[] { yzd
            .getbRJBXXid(), yzd
            .getRegisterLsh(), yzd
            .getLsh() });
      for (MZSFD temp : sfd) {
        if (temp.getZt().compareTo(DictConst.SFD_zt_结账) >= 0)
          ThrowException.runtime("emr.yzd.zt.4", new Object[] { yzd.getLsh() }); 
      } 
      for (MZSFD temp : sfd) {
        if (temp.getZt().compareTo(DictConst.SFD_zt_作废) > 0)
          this.billService.deleteBill(temp.getLsh()); 
      } 
    } 
    yzd.setZt(cancel ? DictConst.YZDZT_作废 : DictConst.YZDZT_删除);
    yzd.setXgsj(bo.getXgsj());
    yzd.setXgrYGid(bo.getXgrYGid());
    yzd.setXgrYGxm(bo.getXgrYGxm());
    JPAUtils.save(yzd);
    Integer zt = cancel ? DictConst.YZDMXZT_作废 : DictConst.YZDMXZT_删除;
    if (yzd.getYpsl().compareTo(DictConst.Int_0) > 0 || yzd.getClsl().compareTo(DictConst.Int_0) > 0)
      JPAUtils.executeUpdate("update MZYZDYPMX set zt=?1, xgsj=?2 where bRJBXXid =?3 and yZDlsh=?4", new Object[] { zt, yzd
            .getXgsj(), yzd.getbRJBXXid(), yzd.getLsh() }); 
    if (yzd.getZlsl().compareTo(DictConst.Int_0) > 0)
      JPAUtils.executeUpdate("update MZYZDZLMX set zt=?1, xgsj=?2 where bRJBXXid =?3 and yZDlsh=?4", new Object[] { zt, yzd
            .getXgsj(), yzd.getbRJBXXid(), yzd.getLsh() }); 
    JPAUtils.executeUpdate("update MZYZCS set scbj=1 where bRJBXXid =?1 and yZDlsh=?2", new Object[] { yzd.getbRJBXXid(), yzd.getLsh() });
    if (yzd.getJjsl().compareTo(DictConst.Int_0) > 0)
      JPAUtils.executeUpdate("update MZYZJJ set zt=0, jjsj=?1 where registerLsh=?2 and yZDlsh=?3", new Object[] { yzd
            .getXgsj(), yzd.getRegisterLsh(), yzd.getLsh() }); 
    if (yzd.getZdsl().compareTo(DictConst.Int_0) > 0)
      JPAUtils.executeUpdate("update MZYZZD set zdbs=0, scrYGid=?1, scsj=?2, xgsj=?3 where bRJBXXid =?4 and yZDlsh=?5 and zdbs>0", new Object[] { yzd
            .getXgrYGid(), yzd.getXgsj(), yzd.getXgsj(), yzd.getbRJBXXid(), yzd.getLsh() }); 
    if (newYzdLsh != null) {
      Map<Integer, YZDMXBase> yzdmxIndex = new HashMap<>();
      if (bo.getYpmx() != null)
        for (MZYZDYPMX temp : bo.getYpmx()) {
          if (IntegerUtils.equals(temp.getyZDlsh(), yzd.getLsh())) {
            yzdmxIndex.put(temp.getLsh(), temp);
            if (temp.getLsh().intValue() > 0)
              temp.setLsh(Integer.valueOf(-temp.getLsh().intValue())); 
            temp.setZt(DictConst.YZDMXZT_新开);
            temp.setSczxsj(null);
            temp.setZzzxsj(null);
            temp.setKszxsj(null);
            temp.setShYGid(null);
            temp.setShjg(null);
            temp.setyZDlsh(newYzdLsh);
          } 
        }  
      if (bo.getZlmx() != null)
        for (MZYZDZLMX temp : bo.getZlmx()) {
          if (IntegerUtils.equals(temp.getyZDlsh(), yzd.getLsh())) {
            yzdmxIndex.put(temp.getLsh(), temp);
            if (temp.getLsh().intValue() > 0)
              temp.setLsh(Integer.valueOf(-temp.getLsh().intValue())); 
            temp.setZt(DictConst.YZDMXZT_新开);
            temp.setSczxsj(null);
            temp.setZzzxsj(null);
            temp.setKszxsj(null);
            temp.setShYGid(null);
            temp.setShjg(null);
            temp.setyZDlsh(newYzdLsh);
          } 
        }  
      YZDMXBase yzdmxTemp = null;
      for (MZYZDYPMX temp : bo.getYpmx()) {
        if (IntegerUtils.equals(temp.getyZDlsh(), newYzdLsh) && temp.getGlYZDMXlsh() != null && yzdmxIndex.containsKey(temp.getGlYZDMXlsh())) {
          yzdmxTemp = yzdmxIndex.get(temp.getGlYZDMXlsh());
          temp.setGlYZDMXlsh(yzdmxTemp.getLsh());
        } 
      } 
      for (MZYZDZLMX temp : bo.getZlmx()) {
        if (IntegerUtils.equals(temp.getyZDlsh(), newYzdLsh) && temp.getGlYZDMXlsh() != null && yzdmxIndex.containsKey(temp.getGlYZDMXlsh())) {
          yzdmxTemp = yzdmxIndex.get(temp.getGlYZDMXlsh());
          temp.setGlYZDMXlsh(yzdmxTemp.getLsh());
        } 
      } 
      if (bo.getYzzd() != null)
        for (MZYZZD temp : bo.getYzzd()) {
          if (IntegerUtils.equals(temp.getyZDlsh(), yzd.getLsh())) {
            temp.setLsh(newYzdLsh);
            temp.setyZDlsh(newYzdLsh);
          } 
        }  
      if (bo.getYzjj() != null)
        for (MZYZJJ temp : bo.getYzjj()) {
          if (IntegerUtils.equals(temp.getyZDlsh(), yzd.getLsh())) {
            yzdmxTemp = yzdmxIndex.get(temp.getyZDMXlsh());
            temp.setyZDMXlsh(yzdmxTemp.getLsh());
            temp.setLsh(newYzdLsh);
            temp.setyZDlsh(newYzdLsh);
          } 
        }  
    } 
  }
  
  public void updateReadCritical(List<LISMZWJZTX> src) {
    Date now = new Date();
    String ckys = LoginUser.getXm() + '(' + LoginUser.getYg().getBh() + ')';
    for (LISMZWJZTX temp : src) {
      LISMZWJZTX dest = (LISMZWJZTX)JPAUtils.findOne(LISMZWJZTX.class, temp.getId());
      if (dest != null) {
        dest.setCkys(ckys);
        dest.setCksj(now);
        dest.setTxzt(DictConst.Int_2);
        dest.setXgsj(now);
        JPAUtils.save(dest);
      } 
    } 
  }
  
  public void updateRisResult(List<MZYZDZLMX> src) {
    for (MZYZDZLMX temp : src) {
      MZYZDZLMX dest = (MZYZDZLMX)JPAUtils.findOne(MZYZDZLMX.class, temp.getLsh());
      if (dest != null) {
        if (IntegerUtils.isBitOn(temp.getYzsx(), 12)) {
          dest.setYzsx(Integer.valueOf(IntegerUtils.bitOn(dest.getYzsx(), 12)));
        } else {
          dest.setYzsx(Integer.valueOf(IntegerUtils.bitOff(dest.getYzsx(), 12)));
        } 
        if (IntegerUtils.isBitOn(temp.getYzsx(), 13)) {
          dest.setYzsx(Integer.valueOf(IntegerUtils.bitOn(dest.getYzsx(), 13)));
          continue;
        } 
        dest.setYzsx(Integer.valueOf(IntegerUtils.bitOff(dest.getYzsx(), 13)));
      } 
    } 
  }
}
